/*

[----------------------------------------]
##########################################
#  ### # ## ###     ##  ###  #    ########
# # ## # # #### ### ## # # # # ### #######
# ## # #  #####     ## ## ## #    ########
# ## # # # #### ### ## ## ## # ###########
# ##  ## ## ### ### ## ##### # ###########
##########################################
[---------Version 1.0 for Allegro--------]

NKAMP and it's code, my hard work, etc. is (C) 1999 Nick Kochakian

Web:    http://come.to/dn3
E-mail: nickk@worldnet.att.net
*/

//The main music player code
#include "nkamp.h"
#include <stdlib.h>
#include <allegro.h>
#include "c:\djgpp\allegro\src\djgpp\adlib.c"

//Gets the values for the current note, etc.
void nkamp_get_values(NKAMP *r, unsigned char pattern, unsigned char cur_line, unsigned char ch,
                unsigned char *note_num, unsigned char *octave,
                unsigned char *inst, unsigned char *e_cmd, unsigned char *e_val) {

unsigned char inst0, inst1;
unsigned char oct;

unsigned char note, inst2, oct2;

note=0;
oct2=0;
inst2=0;

*e_cmd=255;
if (r->Pat[pattern].channel[ch].line[cur_line].is_used==1) {
   note=(r->Pat[pattern].channel[ch].line[cur_line].note[0] & 0xF);

   if (note>=1 && note<=12) {
      oct=(r->Pat[pattern].channel[ch].line[cur_line].note[0] & 0x7F);
      oct2=(oct>>4);
   }

   if (note>0) {
      //Bit 8 of note[0] = bit 4 of the instrument num:
      inst1=(r->Pat[pattern].channel[ch].line[cur_line].note[0]>>8);
      //Bits 4-8 of note[1] = bits 1-3 of the inst num:
      inst0=(r->Pat[pattern].channel[ch].line[cur_line].note[1]>>4);

      inst2=(inst0 | inst1);
      inst2--;
   }

   if ((r->Pat[pattern].channel[ch].line[cur_line].note[1] & 0xF) != 0) {
      //An effect was used
      *e_cmd=(r->Pat[pattern].channel[ch].line[cur_line].note[1] & 0xF);
      *e_val=(r->Pat[pattern].channel[ch].line[cur_line].effect & 0x7F);
   }
}

*note_num=note;
*octave=oct2;
*inst=inst2;
}

//Resets the channel and effect info:
void nkamp_reset_channels() {

int i;

for (i=0; i<9; i++) {
    adl_channels[i].note=0;
    adl_channels[i].vol=64;
    adl_channels[i].freq=0;

    rad_effects[i].command=255;
    rad_effects[i].speed=255;
}

}

//Gets the sound system ready for the player:
int nkamp_init() {

int i;

nkamp_flags.NKAMP_Loop=1;
nkamp_flags.use_volume=nkamp_flags.use_effects=1;

//Is there memory allocated for the pointer's structure?
if (NKAMP_Music==NULL) {
   NKAMP_Music=(NKAMP *)malloc(sizeof(NKAMP));
   nkamp_flags.NKAMP_Handler_installed=0;
}

//Check to see if the synth has been inited:
if (midi_driver->id==MIDI_NONE || midi_driver->id==MIDI_MPU ||
   midi_driver->id==MIDI_DIGMID) //Eeeyych! Non synth modes! :P
   return -1;

//Check to see if the synth has enough voices allocated:
if (midi_driver->max_voices<9)
   return -1;

//Turn off all of the voices, just in case :)
for (i=0; i<9; i++)
    midi_driver->key_off(i);

if (midi_driver->id==MIDI_OPL3) { //Looks like this card supporst STEREO
                                  //sound! :) All of the 9 channels need to
                                  //be centered:
   for (i=0; i<9; i++)
       midi_driver->set_pan(i, 0x20);
}

//Time to toggle some "switches" :)

fm_write(0x01, 0x20);
//fm_write(0x08, 0x0);
fm_write(0xBD, 0);

//Everything went ok!
return 0;
}

//Sets up the player and starts to play the music!
int nkamp_play(NKAMP *music, int loop) {

if (loop==0 || loop==1)
   nkamp_flags.NKAMP_Loop=loop;

if (nkamp_flags.NKAMP_Handler_installed==1) {
   remove_int(nkamp_music_handler);
   nkamp_flags.NKAMP_Handler_installed=0;
}

nkamp_flags.music_is_playing=0;
if (music==NULL)
   return -1;

NKAMP_Music=music;

//Reset some flags:
nkamp_flags.speed_counter=0;

//Install the music handler:
if (music->slow_timer==0)
   install_int_ex(nkamp_music_handler, BPS_TO_TIMER(50));
   else
   install_int_ex(nkamp_music_handler, BPS_TO_TIMER(19));

nkamp_flags.NKAMP_Handler_installed=1;
nkamp_flags.music_is_playing=1; //Let the music play!

return 0;
}

int nkamp_stop() {

int i;

if (nkamp_flags.music_is_playing==1) {
   nkamp_flags.music_is_playing=0;
   for (i=0; i<9; i++)
       midi_driver->key_off(i);
} else if (nkamp_flags.music_is_playing==0 || NKAMP_Music==NULL)
          return -1;

return 0;
}

int nkamp_resume() {

int i;

if (NKAMP_Music==NULL)
   return -1;

if (nkamp_flags.music_is_playing==0) {
   nkamp_flags.music_is_playing=1;
   return 0;
}

return -1;
}

void nkamp_keyon(int voice, int freq, int octave) {
int regNum, tmp;

regNum = 0xA0 + voice % 11;
fm_write(regNum, freq & 0xFF);

regNum = 0xB0 + voice % 11;
tmp = (freq >> 8) | (octave << 2) | 0x20;
fm_write(regNum, tmp);
}

void nkamp_apply_channels() {

int i;
int o_tmp, f_tmp;

//RAD effects:
for (i=0; i<9; i++) {
    if (rad_effects[i].command != 255) {

       if (rad_effects[i].command==1) //Freq slide UP
          adl_channels[i].freq += rad_effects[i].value;
          else if (rad_effects[i].command==2) //Freq slide DOWN
                  adl_channels[i].freq -= rad_effects[i].value;
          else if (rad_effects[i].command==3) {
//                     adl_channels[i].freq -= rad_effects[i].value;
//                     adl_channels[i].octave -= rad_effects[i].value;
          } else if (rad_effects[i].command==5) {
//                    adl_channels[i].freq -= rad_effects[i].value;
//                    adl_channels[i].octave -= rad_effects[i].value;

                  if (rad_effects[i].value>=1 && rad_effects[i].value<=49)
                     adl_channels[i].vol -= rad_effects[i].value;
                     else if (rad_effects[i].value>=51 && rad_effects[i].value<=99)
                             adl_channels[i].vol += (rad_effects[i].value - 50);
          } else if (rad_effects[i].command==10) { //Volume Slide
                  //1-49:  Slide down
                  //51-99: Slide up

                  if (rad_effects[i].value>=1 && rad_effects[i].value<=49)
                     adl_channels[i].vol -= rad_effects[i].value;
                     else if (rad_effects[i].value>=51 && rad_effects[i].value<=99)
                             adl_channels[i].vol += (rad_effects[i].value - 50);
          } else if (rad_effects[i].command==12) //Set Volume
                    adl_channels[i].vol=rad_effects[i].value;

          if (adl_channels[i].freq<0x16B)
             adl_channels[i].freq=0x16B;
             else if (adl_channels[i].freq>0x2AE)
                     adl_channels[i].freq=0x2AE;
       if (adl_channels[i].vol<0)
          adl_channels[i].vol=0;
          else if (adl_channels[i].vol>64)
                  adl_channels[i].vol=64;
       if (adl_channels[i].octave<0)
          adl_channels[i].octave=0;
          else if (adl_channels[i].octave>7)
                  adl_channels[i].octave=7;

        if (rad_effects[i].command==5 || rad_effects[i].command==10 ||
            rad_effects[i].command==12 && nkamp_flags.use_volume==1)
           midi_driver->set_volume(i, adl_channels[i].vol);

        if (rad_effects[i].command>=1 && rad_effects[i].command<=5)
           nkamp_keyon(i, adl_channels[i].freq,
                       adl_channels[i].octave);

//        if (rad_effects[i].command != 3 && rad_effects[i].command != 5)
           rad_effects[i].command=255;
    }
}

}

void nkamp_play_inst(NKAMP *r, int voice, unsigned char n, unsigned char freq, unsigned char octave) {

int i;
int freq_start, freq_end, freq_range;
int note_freq[] = { 0x16B, 0x181, 0x198, 0x1B0, 0x1CA, 0x1E5,
                    0x202, 0x220, 0x241, 0x263, 0x287, 0x2AE };

int adlNum, adlOffset, adlVoice;

freq_start=0x156;
freq_end=0x2AE;
freq_range=freq_end-freq_start;

adl_channels[voice].note=adl_channels[voice].freq=note_freq[freq];
adl_channels[voice].octave=octave;

midi_driver->key_off(voice);

adlVoice=voice;
adlVoice %= 11;
adlOffset = adlVoice % 3 + ((adlVoice / 3) << 3);

adlNum = 0x20 + (char)adlOffset;
fm_write(adlNum, r->Inst[n].m0);
adlNum += 3;
fm_write(adlNum, r->Inst[n].c0);

adlNum = 0x40 + (char)adlOffset;
fm_write(adlNum, r->Inst[n].m1);
adlNum += 3;
fm_write(adlNum, r->Inst[n].c1);

adlNum = 0x60 + (char)adlOffset;
fm_write(adlNum, r->Inst[n].m2);
adlNum += 3;
fm_write(adlNum, r->Inst[n].c2);

adlNum = 0x80 + (char)adlOffset;
fm_write(adlNum, r->Inst[n].m3);
adlNum += 3;
fm_write(adlNum, r->Inst[n].c3);

adlNum = 0xE0 + (char)adlOffset;
fm_write(adlNum, r->Inst[n].m4);
adlNum += 3;
fm_write(adlNum, r->Inst[n].c4);

adlNum = (unsigned char)0xC0 + (unsigned char)adlVoice;
fm_write(adlNum, r->Inst[n].cm);

nkamp_keyon(voice, note_freq[freq], (int)octave);
}

void nkamp_music_handler() {

unsigned char jumped;
unsigned char play_note, play_octave, use_inst, e_cmd, e_val;
int c;
int i;

if (nkamp_flags.music_is_playing==1) {
   nkamp_flags.speed_counter++;
   if (nkamp_flags.speed_counter>=NKAMP_Music->cur_speed) {
       nkamp_flags.speed_counter=0;
       NKAMP_Music->cur_pattern=NKAMP_Music->Order[NKAMP_Music->cur_order].play_pattern;

       jumped=255;
       for (i=0; i<9; i++) {
           nkamp_get_values(NKAMP_Music, NKAMP_Music->cur_pattern, NKAMP_Music->cur_line, i,
                            &play_note, &play_octave, &use_inst, &e_cmd, &e_val);

           if (e_cmd==13 && e_val<64) //Pattern break
              jumped=e_val;
              else if (e_cmd==15 && e_val>=1 && e_val<=31) //Change speed
                      NKAMP_Music->cur_speed=e_val;
              else if (e_cmd != 255) {
                      rad_effects[i].command=e_cmd;
                      rad_effects[i].value=e_val;
              }

           if (play_note==15) { //Key note off
  //            midi_driver->key_off(i);
              nkamp_keyon(i, adl_channels[i].freq,
                          adl_channels[i].octave);
           } else if (play_note>=1 && play_note<=12) {
                     adl_channels[i].vol=64;
                     nkamp_play_inst(NKAMP_Music, i, use_inst, play_note-1, play_octave);
           }
         }

         if (nkamp_flags.use_effects==1)
            nkamp_apply_channels();

         NKAMP_Music->cur_line++;
         if (NKAMP_Music->cur_line>=64 || jumped != 255) {
            if (jumped != 255)
               NKAMP_Music->cur_line=jumped;
               else
               NKAMP_Music->cur_line=0;

            NKAMP_Music->cur_order++;
            if (NKAMP_Music->cur_order>=NKAMP_Music->num_orders-1 &&
               nkamp_flags.NKAMP_Loop==1) {
               if (NKAMP_Music->Order[NKAMP_Music->cur_order].play_pattern>=128) {
                  c=NKAMP_Music->Order[NKAMP_Music->cur_order].play_pattern;
                  NKAMP_Music->cur_order=c-0x80;
               } else
                 NKAMP_Music->cur_order=0;
               } else if (NKAMP_Music->cur_order>=NKAMP_Music->num_orders-1 &&
                          nkamp_flags.NKAMP_Loop==0) {
                          nkamp_flags.music_is_playing=0;
                          for (i=0; i<9; i++)
                              midi_driver->key_off(i);
                          return;
               }
            }

   }
}

}

END_OF_FUNCTION(nkamp_music_handler);

int free_nkamp(NKAMP *music) {

if (music==NULL)
   return -1;

free(music->Pat);
free(music->Inst);
free(music->Order);
free(music);

return 0;
}
